import { AnyAction } from 'redux';
import { FunctionProducer } from './function_producer';
import { PodInstance, ActionCreator, InternalProxiedAction, ProxiedActionMembers } from './interfaces';
export declare class ProxiedAction<A extends ActionCreator> extends FunctionProducer<ProxiedActionMembers<A>, InternalProxiedAction<A>> {
    private type;
    private instance;
    private actionCreator;
    constructor(type: string, instance: PodInstance, actionCreator: A);
    getType(): string;
    getActionCreator(): A;
    proxiedStatefulAction(args: any): {
        type: string;
        arguments: any;
    };
    proxiedBasicAction(args: any): {
        type: string;
    } | {
        type: string;
    };
    process(state: any, action: ReturnType<InternalProxiedAction<A>>): void | {};
    match(action: AnyAction): boolean;
    boundFunctionMembers(): ProxiedActionMembers<A>;
}
