"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var actionTypes = __importStar(require("./actiontype"));
var function_producer_1 = require("./function_producer");
var ProxiedAction = /** @class */ (function (_super) {
    __extends(ProxiedAction, _super);
    function ProxiedAction(type, instance, actionCreator) {
        var _this = _super.call(this, function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return typeof actionCreator.apply(void 0, __spread(args)) === 'function'
                ? _this.proxiedStatefulAction(args)
                : _this.proxiedBasicAction(args);
        }) || this;
        _this.type = type;
        _this.instance = instance;
        _this.actionCreator = actionCreator;
        return _this;
    }
    ProxiedAction.prototype.getType = function () {
        return this.type;
    };
    ProxiedAction.prototype.getActionCreator = function () {
        return this.actionCreator;
    };
    ProxiedAction.prototype.proxiedStatefulAction = function (args) {
        return {
            type: actionTypes.getActionKey(this.type),
            arguments: args
        };
    };
    ProxiedAction.prototype.proxiedBasicAction = function (args) {
        return __assign(__assign({}, this.actionCreator.apply(this, __spread(args))), { type: actionTypes.getActionKey(this.type) });
    };
    ProxiedAction.prototype.process = function (state, action) {
        if (action.arguments) {
            var res = this.actionCreator.apply(this, __spread(action.arguments));
            if (typeof res === 'function') {
                return res(state);
            }
        }
    };
    ProxiedAction.prototype.match = function (action) {
        return (actionTypes.isActionOf(this.instance().getProps().path, action) &&
            actionTypes.getReversedActionKey(action.type) === this.type);
    };
    ProxiedAction.prototype.boundFunctionMembers = function () {
        var _this = this;
        return {
            instance: function () { return _this; }
        };
    };
    return ProxiedAction;
}(function_producer_1.FunctionProducer));
exports.ProxiedAction = ProxiedAction;
