"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var action_1 = require("./action");
function chainedActionSet(instance, existingActionSet, actionSetToChain) {
    if (existingActionSet === void 0) { existingActionSet = {}; }
    var keys = Object.keys(existingActionSet);
    if (Object.keys(actionSetToChain).some(function (key) { return keys.includes(key); })) {
        throw new Error("One of more of the action keys provided have already been defined.");
    }
    return Object.keys(actionSetToChain).reduce(function (actions, key) {
        var _a;
        return (__assign(__assign({}, actions), (_a = {}, _a[key] = new action_1.ProxiedAction(key, instance, actionSetToChain[key]), _a)));
    }, existingActionSet);
}
exports.chainedActionSet = chainedActionSet;
