"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ACTION_TYPE_PREFIX = '@@ReduxPods';
exports.INTERNAL_ACTION_TYPES = {
    init: generatePodActionType('Internal', 'Init'),
    connect: generatePodActionType('Internal', 'Connect'),
    registerTrackers: generatePodActionType('Internal', 'RegisterTrackers'),
    tracker: generatePodActionType('Internal', 'Tracker')
};
function generatePodActionType() {
    var suffix = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        suffix[_i] = arguments[_i];
    }
    return exports.ACTION_TYPE_PREFIX + "/" + suffix.join('/');
}
exports.generatePodActionType = generatePodActionType;
function getActionKey(key) {
    return generatePodActionType('Action', key);
}
exports.getActionKey = getActionKey;
function getReversedActionKey(actionKey) {
    return actionKey.replace(getActionKey(), '');
}
exports.getReversedActionKey = getReversedActionKey;
function isActionOf(podPath, action) {
    return action.type.startsWith(getActionKey()) && podPath === action.path;
}
exports.isActionOf = isActionOf;
