"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
function effect(func) {
    return func;
}
exports.effect = effect;
function actionTypeEffect(types, func) {
    var isArrayOfStrings = Array.isArray(types) &&
        types.every(function (key) {
            return typeof key === 'string';
        });
    if (!isArrayOfStrings) {
        throw new Error("\n      Invalid action types argument of type " + typeof types + "; expected an array of strings.\n    ");
    }
    return effect(function (state, action) {
        if (types.includes(action.type)) {
            return func(state, action);
        }
    });
}
exports.actionTypeEffect = actionTypeEffect;
function internalReducerEffect(actionSet, func) {
    if (actionSet === void 0) { actionSet = {}; }
    var proxiedActions = Object.values(actionSet);
    if (proxiedActions.length === 0) {
        throw new Error("There are no actions available to track. Set your action set before creating an internal reducer.");
    }
    return effect(function (state, action) {
        var proxiedAction = proxiedActions.find(function (proxied) {
            return proxied.match(action);
        });
        if (proxiedAction) {
            return func(state, __assign(__assign({}, action), { type: proxiedAction.getType() }));
        }
    });
}
exports.internalReducerEffect = internalReducerEffect;
