import { StoreEnhancer, AnyAction } from 'redux';
import { PodInstance } from './interfaces';
import { PodReducer } from './reducer';
export interface ReduxPodEnhancerOptions {
    initializeOn(action: AnyAction): boolean;
}
export interface ReduxPodEnhancerContext {
    pathSet: string[];
    trackedPaths: Map<string, any>;
}
export interface InternalInitAction<S> extends AnyAction {
    init(initialState: S): S;
}
export interface InternalConnectAction<S> extends AnyAction {
    connect(state: S, pod: PodReducer<S, any>): S;
}
export interface InternalRegisterTrackerAction extends AnyAction {
    register(trackedPod: PodInstance): void;
}
export interface InternalTrackerAction<T> extends AnyAction {
    currentState: T;
    previousState: T;
    path: string;
}
export declare function reduxPodEnhancer(options?: Partial<ReduxPodEnhancerOptions>): StoreEnhancer;
