import { AnyAction } from 'redux';
import { PodReducer } from './reducer';
import { ChainedPod, ActionSet, ExplicitlyTypedAction, Effect, ResolvedPodTracker, ResolvedActionTracker, ExposedActionCreator } from './interfaces';
export declare class PodMethods<S, A extends ActionSet<S>> {
    constructor(instance: PodReducer<S, A>);
    path(): string;
    connected(): boolean;
    actionSet(): import("./interfaces").ProxiedActionSet<A>;
    props(): import("./properties").PodProperties<S, A>;
    instance(): PodReducer<S, A>;
    mapState(storeState: any): S;
    mapState<P extends keyof S>(storeState: any, ...subPath: P[]): Pick<S, P>;
    mapState<R extends any>(storeState: any, selector: (state: S) => R): R extends void ? S : R;
    on<N extends ActionSet<S>>(actions: N): ChainedPod<S, A & N>;
    on<T extends any>(actionType: string | string[], effect: Effect<S, T>): ChainedPod<S, A>;
    track<TState>(pod: ChainedPod<TState, any>, tracker: ResolvedPodTracker<TState, S>): ChainedPod<S, A>;
    track<TAction extends ExposedActionCreator<any>>(action: TAction, tracker: ResolvedActionTracker<TAction, S>): ChainedPod<S, A>;
    reduce(effect: Effect<S, ExplicitlyTypedAction<keyof A>>): ChainedPod<S, A>;
    reduceAny<T extends AnyAction>(effect: Effect<S, T>): ChainedPod<S, A>;
    extend<ExtendedState>(extendedState?: ExtendedState): ChainedPod<S & ExtendedState, A & {}>;
}
