"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * The `PodProperties` class contains all of the central properties for each pod
 * along with all of the chained properties such as action creators and effects.
 *
 * An instance of this class is created when initially calling the root `pod` function
 * and subsequently copied & extended when chaining the pod through reducer methods.
 */
var PodProperties = /** @class */ (function () {
    /**
     * Pod properties class constructor accepts a partial properties object and applies
     * the obj. members to itself.
     *
     * @param properties Partial properties object.
     */
    function PodProperties(properties) {
        Object.assign(this, properties);
    }
    return PodProperties;
}());
exports.PodProperties = PodProperties;
