"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var actiontype_1 = require("./actiontype");
var effect_1 = require("./effect");
function podTrackerEffect(pod, tracker) {
    return effect_1.effect(function (state, action) {
        if (action.type === actiontype_1.INTERNAL_ACTION_TYPES.tracker &&
            action.path === pod.path()) {
            var res = tracker(action.currentState, action.previousState);
            if (typeof res === 'function') {
                return res(state);
            }
        }
    });
}
exports.podTrackerEffect = podTrackerEffect;
function actionTrackerEffect(podAction, func) {
    return effect_1.effect(function (state, action) {
        if (podAction.instance().match(action)) {
            var res = func.apply(void 0, __spread(action.arguments));
            if (res) {
                return res(state);
            }
        }
    });
}
exports.actionTrackerEffect = actionTrackerEffect;
