"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var reducer_1 = require("./reducer");
var action_1 = require("./action");
function mergeEffects(existingEffect, newEffect) {
    if (typeof newEffect !== 'function') {
        throw new Error("Invalid reducer of type " + typeof newEffect + "; function expected.");
    }
    return !existingEffect
        ? newEffect
        : (function (state, action) {
            var res = existingEffect(state, action);
            return newEffect(res === undefined ? state : res, action);
        });
}
exports.mergeEffects = mergeEffects;
function findPath(obj, toFind) {
    var path = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        path[_i - 2] = arguments[_i];
    }
    if (toFind === undefined || toFind === null) {
        return '';
    }
    if (Object.is(obj, toFind)) {
        return path.join('.');
    }
    if (typeof obj === 'object') {
        for (var key in obj) {
            if (key) {
                var res = findPath.apply(void 0, __spread([obj[key], toFind], path.concat(key)));
                if (typeof res === 'string') {
                    return res;
                }
            }
        }
    }
    return undefined;
}
exports.findPath = findPath;
function isPod(pod) {
    return (typeof pod === 'function' &&
        typeof pod.instance === 'function' &&
        pod.instance() instanceof reducer_1.PodReducer);
}
exports.isPod = isPod;
function isActionSet(obj) {
    return (typeof obj === 'object' &&
        Object.values(obj).every(function (val) {
            return typeof val === 'function';
        }));
}
exports.isActionSet = isActionSet;
function isProxiedAction(val) {
    return (typeof val === 'function' &&
        typeof val.instance === 'function' &&
        val.instance() instanceof action_1.ProxiedAction);
}
exports.isProxiedAction = isProxiedAction;
